diff --git a/roms/ipxe/src/crypto/sha1.c b/roms/ipxe/src/crypto/sha1.c
new file mode 100644
index 0000000000000000000000000000000000000000..e1bef669ee96a014bf272268354dbd51cca30f1f
--- /dev/null
+++ b/roms/ipxe/src/crypto/sha1.c
@@ -0,0 +1,272 @@
+/*
+ * Copyright (C) 2012 Michael Brown <mbrown@fensystems.co.uk>.
+ *
+ * This program is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU General Public License as
+ * published by the Free Software Foundation; either version 2 of the
+ * License, or any later version.
+ *
+ * This program is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+ * 02110-1301, USA.
+ */
+
+FILE_LICENCE ( GPL2_OR_LATER );
+
+/** @file
+ *
+ * SHA-1 algorithm
+ *
+ */
+
+#include <stdint.h>
+#include <string.h>
+#include <byteswap.h>
+#include <assert.h>
+#include <ipxe/rotate.h>
+#include <ipxe/crypto.h>
+#include <ipxe/asn1.h>
+#include <ipxe/sha1.h>
+
+/** SHA-1 variables */
+struct sha1_variables {
+	/* This layout matches that of struct sha1_digest_data,
+	 * allowing for efficient endianness-conversion,
+	 */
+	uint32_t a;
+	uint32_t b;
+	uint32_t c;
+	uint32_t d;
+	uint32_t e;
+	uint32_t w[80];
+} __attribute__ (( packed ));
+
+/**
+ * f(a,b,c,d) for steps 0 to 19
+ *
+ * @v v		SHA-1 variables
+ * @ret f	f(a,b,c,d)
+ */
+static uint32_t sha1_f_0_19 ( struct sha1_variables *v ) {
+	return ( ( v->b & v->c ) | ( (~v->b) & v->d ) );
+}
+
+/**
+ * f(a,b,c,d) for steps 20 to 39 and 60 to 79
+ *
+ * @v v		SHA-1 variables
+ * @ret f	f(a,b,c,d)
+ */
+static uint32_t sha1_f_20_39_60_79 ( struct sha1_variables *v ) {
+	return ( v->b ^ v->c ^ v->d );
+}
+
+/**
+ * f(a,b,c,d) for steps 40 to 59
+ *
+ * @v v		SHA-1 variables
+ * @ret f	f(a,b,c,d)
+ */
+static uint32_t sha1_f_40_59 ( struct sha1_variables *v ) {
+	return ( ( v->b & v->c ) | ( v->b & v->d ) | ( v->c & v->d ) );
+}
+
+/** An SHA-1 step function */
+struct sha1_step {
+	/**
+	 * Calculate f(a,b,c,d)
+	 *
+	 * @v v		SHA-1 variables
+	 * @ret f	f(a,b,c,d)
+	 */
+	uint32_t ( * f ) ( struct sha1_variables *v );
+	/** Constant k */
+	uint32_t k;
+};
+
+/** SHA-1 steps */
+static struct sha1_step sha1_steps[4] = {
+	/** 0 to 19 */
+	{ .f = sha1_f_0_19,		.k = 0x5a827999 },
+	/** 20 to 39 */
+	{ .f = sha1_f_20_39_60_79,	.k = 0x6ed9eba1 },
+	/** 40 to 59 */
+	{ .f = sha1_f_40_59,		.k = 0x8f1bbcdc },
+	/** 60 to 79 */
+	{ .f = sha1_f_20_39_60_79,	.k = 0xca62c1d6 },
+};
+
+/**
+ * Initialise SHA-1 algorithm
+ *
+ * @v ctx		SHA-1 context
+ */
+static void sha1_init ( void *ctx ) {
+	struct sha1_context *context = ctx;
+
+	context->ddd.dd.digest.h[0] = cpu_to_be32 ( 0x67452301 );
+	context->ddd.dd.digest.h[1] = cpu_to_be32 ( 0xefcdab89 );
+	context->ddd.dd.digest.h[2] = cpu_to_be32 ( 0x98badcfe );
+	context->ddd.dd.digest.h[3] = cpu_to_be32 ( 0x10325476 );
+	context->ddd.dd.digest.h[4] = cpu_to_be32 ( 0xc3d2e1f0 );
+	context->len = 0;
+}
+
+/**
+ * Calculate SHA-1 digest of accumulated data
+ *
+ * @v context		SHA-1 context
+ */
+static void sha1_digest ( struct sha1_context *context ) {
+        union {
+		union sha1_digest_data_dwords ddd;
+		struct sha1_variables v;
+	} u;
+	uint32_t *a = &u.v.a;
+	uint32_t *b = &u.v.b;
+	uint32_t *c = &u.v.c;
+	uint32_t *d = &u.v.d;
+	uint32_t *e = &u.v.e;
+	uint32_t *w = u.v.w;
+	uint32_t f;
+	uint32_t k;
+	uint32_t temp;
+	struct sha1_step *step;
+	unsigned int i;
+
+	/* Sanity checks */
+	assert ( ( context->len % sizeof ( context->ddd.dd.data ) ) == 0 );
+	linker_assert ( &u.ddd.dd.digest.h[0] == a, sha1_bad_layout );
+	linker_assert ( &u.ddd.dd.digest.h[1] == b, sha1_bad_layout );
+	linker_assert ( &u.ddd.dd.digest.h[2] == c, sha1_bad_layout );
+	linker_assert ( &u.ddd.dd.digest.h[3] == d, sha1_bad_layout );
+	linker_assert ( &u.ddd.dd.digest.h[4] == e, sha1_bad_layout );
+	linker_assert ( &u.ddd.dd.data.dword[0] == w, sha1_bad_layout );
+
+	DBGC ( context, "SHA1 digesting:\n" );
+	DBGC_HDA ( context, 0, &context->ddd.dd.digest,
+		   sizeof ( context->ddd.dd.digest ) );
+	DBGC_HDA ( context, context->len, &context->ddd.dd.data,
+		   sizeof ( context->ddd.dd.data ) );
+
+	/* Convert h[0..4] to host-endian, and initialise a, b, c, d,
+	 * e, and w[0..15]
+	 */
+	for ( i = 0 ; i < ( sizeof ( u.ddd.dword ) /
+			    sizeof ( u.ddd.dword[0] ) ) ; i++ ) {
+		be32_to_cpus ( &context->ddd.dword[i] );
+		u.ddd.dword[i] = context->ddd.dword[i];
+	}
+
+	/* Initialise w[16..79] */
+	for ( i = 16 ; i < 80 ; i++ )
+		w[i] = rol32 ( ( w[i-3] ^ w[i-8] ^ w[i-14] ^ w[i-16] ), 1 );
+
+	/* Main loop */
+	for ( i = 0 ; i < 80 ; i++ ) {
+		step = &sha1_steps[ i / 20 ];
+		f = step->f ( &u.v );
+		k = step->k;
+		temp = ( rol32 ( *a, 5 ) + f + *e + k + w[i] );
+		*e = *d;
+		*d = *c;
+		*c = rol32 ( *b, 30 );
+		*b = *a;
+		*a = temp;
+		DBGC2 ( context, "%2d : %08x %08x %08x %08x %08x\n",
+			i, *a, *b, *c, *d, *e );
+	}
+
+	/* Add chunk to hash and convert back to big-endian */
+	for ( i = 0 ; i < 5 ; i++ ) {
+		context->ddd.dd.digest.h[i] =
+			cpu_to_be32 ( context->ddd.dd.digest.h[i] +
+				      u.ddd.dd.digest.h[i] );
+	}
+
+	DBGC ( context, "SHA1 digested:\n" );
+	DBGC_HDA ( context, 0, &context->ddd.dd.digest,
+		   sizeof ( context->ddd.dd.digest ) );
+}
+
+/**
+ * Accumulate data with SHA-1 algorithm
+ *
+ * @v ctx		SHA-1 context
+ * @v data		Data
+ * @v len		Length of data
+ */
+static void sha1_update ( void *ctx, const void *data, size_t len ) {
+	struct sha1_context *context = ctx;
+	const uint8_t *byte = data;
+	size_t offset;
+
+	/* Accumulate data a byte at a time, performing the digest
+	 * whenever we fill the data buffer
+	 */
+	while ( len-- ) {
+		offset = ( context->len % sizeof ( context->ddd.dd.data ) );
+		context->ddd.dd.data.byte[offset] = *(byte++);
+		context->len++;
+		if ( ( context->len % sizeof ( context->ddd.dd.data ) ) == 0 )
+			sha1_digest ( context );
+	}
+}
+
+/**
+ * Generate SHA-1 digest
+ *
+ * @v ctx		SHA-1 context
+ * @v out		Output buffer
+ */
+static void sha1_final ( void *ctx, void *out ) {
+	struct sha1_context *context = ctx;
+	uint64_t len_bits;
+	uint8_t pad;
+
+	/* Record length before pre-processing */
+	len_bits = cpu_to_be64 ( ( ( uint64_t ) context->len ) * 8 );
+
+	/* Pad with a single "1" bit followed by as many "0" bits as required */
+	pad = 0x80;
+	do {
+		sha1_update ( ctx, &pad, sizeof ( pad ) );
+		pad = 0x00;
+	} while ( ( context->len % sizeof ( context->ddd.dd.data ) ) !=
+		  offsetof ( typeof ( context->ddd.dd.data ), final.len ) );
+
+	/* Append length (in bits) */
+	sha1_update ( ctx, &len_bits, sizeof ( len_bits ) );
+	assert ( ( context->len % sizeof ( context->ddd.dd.data ) ) == 0 );
+
+	/* Copy out final digest */
+	memcpy ( out, &context->ddd.dd.digest,
+		 sizeof ( context->ddd.dd.digest ) );
+}
+
+/** SHA-1 algorithm */
+struct digest_algorithm sha1_algorithm = {
+	.name		= "sha1",
+	.ctxsize	= sizeof ( struct sha1_context ),
+	.blocksize	= sizeof ( union sha1_block ),
+	.digestsize	= sizeof ( struct sha1_digest ),
+	.init		= sha1_init,
+	.update		= sha1_update,
+	.final		= sha1_final,
+};
+
+/** "sha1" object identifier */
+static uint8_t oid_sha1[] = { ASN1_OID_SHA1 };
+
+/** "sha1" OID-identified algorithm */
+struct asn1_algorithm oid_sha1_algorithm __asn1_algorithm = {
+	.name = "sha1",
+	.digest = &sha1_algorithm,
+	.oid = ASN1_OID_CURSOR ( oid_sha1 ),
+};
diff --git a/roms/ipxe/src/crypto/sha1extra.c b/roms/ipxe/src/crypto/sha1extra.c
index 74445e9d1977390f4d6ceda0f3e3..cec0d35e5bf4251c0b56d3b604cf 100644
--- a/roms/ipxe/src/crypto/sha1extra.c
+++ b/roms/ipxe/src/crypto/sha1extra.c
@@ -13,11 +13,13 @@
  *
  * You should have received a copy of the GNU General Public License
  * along with this program; if not, write to the Free Software
- * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+ * 02110-1301, USA.
  */
 
 FILE_LICENCE ( GPL2_OR_LATER );
 
+#include <string.h>
 #include <ipxe/crypto.h>
 #include <ipxe/sha1.h>
 #include <ipxe/hmac.h>
@@ -46,7 +48,7 @@ void prf_sha1 ( const void *key, size_t key_len, const char *label,
 	u8 keym[key_len];	/* modifiable copy of key */
 	u8 in[strlen ( label ) + 1 + data_len + 1]; /* message to HMAC */
 	u8 *in_blknr;		/* pointer to last byte of in, block number */
-	u8 out[SHA1_SIZE];	/* HMAC-SHA1 result */
+	u8 out[SHA1_DIGEST_SIZE]; /* HMAC-SHA1 result */
 	u8 sha1_ctx[SHA1_CTX_SIZE]; /* SHA1 context */
 	const size_t label_len = strlen ( label );
 
@@ -67,14 +69,14 @@ void prf_sha1 ( const void *key, size_t key_len, const char *label,
 		hmac_update ( &sha1_algorithm, sha1_ctx, in, sizeof ( in ) );
 		hmac_final ( &sha1_algorithm, sha1_ctx, keym, &key_len, out );
 
-		if ( prf_len <= SHA1_SIZE ) {
+		if ( prf_len <= sizeof ( out ) ) {
 			memcpy ( prf, out, prf_len );
 			break;
 		}
 
-		memcpy ( prf, out, SHA1_SIZE );
-		prf_len -= SHA1_SIZE;
-		prf += SHA1_SIZE;
+		memcpy ( prf, out, sizeof ( out ) );
+		prf_len -= sizeof ( out );
+		prf += sizeof ( out );
 	}
 }
 
@@ -97,30 +99,31 @@ static void pbkdf2_sha1_f ( const void *passphrase, size_t pass_len,
 {
 	u8 pass[pass_len];	/* modifiable passphrase */
 	u8 in[salt_len + 4];	/* input buffer to first round */
-	u8 last[SHA1_SIZE];	/* output of round N, input of N+1 */
+	u8 last[SHA1_DIGEST_SIZE]; /* output of round N, input of N+1 */
 	u8 sha1_ctx[SHA1_CTX_SIZE];
 	u8 *next_in = in;	/* changed to `last' after first round */
 	int next_size = sizeof ( in );
-	int i, j;
+	int i;
+	unsigned int j;
 
 	blocknr = htonl ( blocknr );
 
 	memcpy ( pass, passphrase, pass_len );
 	memcpy ( in, salt, salt_len );
 	memcpy ( in + salt_len, &blocknr, 4 );
-	memset ( block, 0, SHA1_SIZE );
+	memset ( block, 0, sizeof ( last ) );
 
 	for ( i = 0; i < iterations; i++ ) {
 		hmac_init ( &sha1_algorithm, sha1_ctx, pass, &pass_len );
 		hmac_update ( &sha1_algorithm, sha1_ctx, next_in, next_size );
 		hmac_final ( &sha1_algorithm, sha1_ctx, pass, &pass_len, last );
 
-		for ( j = 0; j < SHA1_SIZE; j++ ) {
+		for ( j = 0; j < sizeof ( last ); j++ ) {
 			block[j] ^= last[j];
 		}
 
 		next_in = last;
-		next_size = SHA1_SIZE;
+		next_size = sizeof ( last );
 	}
 }
 
@@ -146,20 +149,20 @@ void pbkdf2_sha1 ( const void *passphrase, size_t pass_len,
 		   const void *salt, size_t salt_len,
 		   int iterations, void *key, size_t key_len )
 {
-	u32 blocks = ( key_len + SHA1_SIZE - 1 ) / SHA1_SIZE;
+	u32 blocks = ( key_len + SHA1_DIGEST_SIZE - 1 ) / SHA1_DIGEST_SIZE;
 	u32 blk;
-	u8 buf[SHA1_SIZE];
+	u8 buf[SHA1_DIGEST_SIZE];
 
 	for ( blk = 1; blk <= blocks; blk++ ) {
 		pbkdf2_sha1_f ( passphrase, pass_len, salt, salt_len,
 				iterations, blk, buf );
-		if ( key_len <= SHA1_SIZE ) {
+		if ( key_len <= sizeof ( buf ) ) {
 			memcpy ( key, buf, key_len );
 			break;
 		}
 
-		memcpy ( key, buf, SHA1_SIZE );
-		key_len -= SHA1_SIZE;
-		key += SHA1_SIZE;
+		memcpy ( key, buf, sizeof ( buf ) );
+		key_len -= sizeof ( buf );
+		key += sizeof ( buf );
 	}
 }
diff --git a/roms/ipxe/src/crypto/sha256.c b/roms/ipxe/src/crypto/sha256.c
new file mode 100644
index 0000000000000000000000000000000000000000..36e02b3c27d9f17fd7a7c65d7d4091aa63b7fc7e
--- /dev/null
+++ b/roms/ipxe/src/crypto/sha256.c
@@ -0,0 +1,256 @@
+/*
+ * Copyright (C) 2012 Michael Brown <mbrown@fensystems.co.uk>.
+ *
+ * This program is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU General Public License as
+ * published by the Free Software Foundation; either version 2 of the
+ * License, or any later version.
+ *
+ * This program is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+ * 02110-1301, USA.
+ */
+
+FILE_LICENCE ( GPL2_OR_LATER );
+
+/** @file
+ *
+ * SHA-256 algorithm
+ *
+ */
+
+#include <stdint.h>
+#include <string.h>
+#include <byteswap.h>
+#include <assert.h>
+#include <ipxe/rotate.h>
+#include <ipxe/crypto.h>
+#include <ipxe/asn1.h>
+#include <ipxe/sha256.h>
+
+/** SHA-256 variables */
+struct sha256_variables {
+	/* This layout matches that of struct sha256_digest_data,
+	 * allowing for efficient endianness-conversion,
+	 */
+	uint32_t a;
+	uint32_t b;
+	uint32_t c;
+	uint32_t d;
+	uint32_t e;
+	uint32_t f;
+	uint32_t g;
+	uint32_t h;
+	uint32_t w[64];
+} __attribute__ (( packed ));
+
+/** SHA-256 constants */
+static const uint32_t k[64] = {
+	0x428a2f98, 0x71374491, 0xb5c0fbcf, 0xe9b5dba5, 0x3956c25b, 0x59f111f1,
+	0x923f82a4, 0xab1c5ed5, 0xd807aa98, 0x12835b01, 0x243185be, 0x550c7dc3,
+	0x72be5d74, 0x80deb1fe, 0x9bdc06a7, 0xc19bf174, 0xe49b69c1, 0xefbe4786,
+	0x0fc19dc6, 0x240ca1cc, 0x2de92c6f, 0x4a7484aa, 0x5cb0a9dc, 0x76f988da,
+	0x983e5152, 0xa831c66d, 0xb00327c8, 0xbf597fc7, 0xc6e00bf3, 0xd5a79147,
+	0x06ca6351, 0x14292967, 0x27b70a85, 0x2e1b2138, 0x4d2c6dfc, 0x53380d13,
+	0x650a7354, 0x766a0abb, 0x81c2c92e, 0x92722c85, 0xa2bfe8a1, 0xa81a664b,
+	0xc24b8b70, 0xc76c51a3, 0xd192e819, 0xd6990624, 0xf40e3585, 0x106aa070,
+	0x19a4c116, 0x1e376c08, 0x2748774c, 0x34b0bcb5, 0x391c0cb3, 0x4ed8aa4a,
+	0x5b9cca4f, 0x682e6ff3, 0x748f82ee, 0x78a5636f, 0x84c87814, 0x8cc70208,
+	0x90befffa, 0xa4506ceb, 0xbef9a3f7, 0xc67178f2
+};
+
+/**
+ * Initialise SHA-256 algorithm
+ *
+ * @v ctx		SHA-256 context
+ */
+static void sha256_init ( void *ctx ) {
+	struct sha256_context *context = ctx;
+
+	context->ddd.dd.digest.h[0] = cpu_to_be32 ( 0x6a09e667 );
+	context->ddd.dd.digest.h[1] = cpu_to_be32 ( 0xbb67ae85 );
+	context->ddd.dd.digest.h[2] = cpu_to_be32 ( 0x3c6ef372 );
+	context->ddd.dd.digest.h[3] = cpu_to_be32 ( 0xa54ff53a );
+	context->ddd.dd.digest.h[4] = cpu_to_be32 ( 0x510e527f );
+	context->ddd.dd.digest.h[5] = cpu_to_be32 ( 0x9b05688c );
+	context->ddd.dd.digest.h[6] = cpu_to_be32 ( 0x1f83d9ab );
+	context->ddd.dd.digest.h[7] = cpu_to_be32 ( 0x5be0cd19 );
+	context->len = 0;
+}
+
+/**
+ * Calculate SHA-256 digest of accumulated data
+ *
+ * @v context		SHA-256 context
+ */
+static void sha256_digest ( struct sha256_context *context ) {
+        union {
+		union sha256_digest_data_dwords ddd;
+		struct sha256_variables v;
+	} u;
+	uint32_t *a = &u.v.a;
+	uint32_t *b = &u.v.b;
+	uint32_t *c = &u.v.c;
+	uint32_t *d = &u.v.d;
+	uint32_t *e = &u.v.e;
+	uint32_t *f = &u.v.f;
+	uint32_t *g = &u.v.g;
+	uint32_t *h = &u.v.h;
+	uint32_t *w = u.v.w;
+	uint32_t s0;
+	uint32_t s1;
+	uint32_t maj;
+	uint32_t t1;
+	uint32_t t2;
+	uint32_t ch;
+	unsigned int i;
+
+	/* Sanity checks */
+	assert ( ( context->len % sizeof ( context->ddd.dd.data ) ) == 0 );
+	linker_assert ( &u.ddd.dd.digest.h[0] == a, sha256_bad_layout );
+	linker_assert ( &u.ddd.dd.digest.h[1] == b, sha256_bad_layout );
+	linker_assert ( &u.ddd.dd.digest.h[2] == c, sha256_bad_layout );
+	linker_assert ( &u.ddd.dd.digest.h[3] == d, sha256_bad_layout );
+	linker_assert ( &u.ddd.dd.digest.h[4] == e, sha256_bad_layout );
+	linker_assert ( &u.ddd.dd.digest.h[5] == f, sha256_bad_layout );
+	linker_assert ( &u.ddd.dd.digest.h[6] == g, sha256_bad_layout );
+	linker_assert ( &u.ddd.dd.digest.h[7] == h, sha256_bad_layout );
+	linker_assert ( &u.ddd.dd.data.dword[0] == w, sha256_bad_layout );
+
+	DBGC ( context, "SHA256 digesting:\n" );
+	DBGC_HDA ( context, 0, &context->ddd.dd.digest,
+		   sizeof ( context->ddd.dd.digest ) );
+	DBGC_HDA ( context, context->len, &context->ddd.dd.data,
+		   sizeof ( context->ddd.dd.data ) );
+
+	/* Convert h[0..7] to host-endian, and initialise a, b, c, d,
+	 * e, f, g, h, and w[0..15]
+	 */
+	for ( i = 0 ; i < ( sizeof ( u.ddd.dword ) /
+			    sizeof ( u.ddd.dword[0] ) ) ; i++ ) {
+		be32_to_cpus ( &context->ddd.dword[i] );
+		u.ddd.dword[i] = context->ddd.dword[i];
+	}
+
+	/* Initialise w[16..63] */
+	for ( i = 16 ; i < 64 ; i++ ) {
+		s0 = ( ror32 ( w[i-15], 7 ) ^ ror32 ( w[i-15], 18 ) ^
+		       ( w[i-15] >> 3 ) );
+		s1 = ( ror32 ( w[i-2], 17 ) ^ ror32 ( w[i-2], 19 ) ^
+		       ( w[i-2] >> 10 ) );
+		w[i] = ( w[i-16] + s0 + w[i-7] + s1 );
+	}
+
+	/* Main loop */
+	for ( i = 0 ; i < 64 ; i++ ) {
+		s0 = ( ror32 ( *a, 2 ) ^ ror32 ( *a, 13 ) ^ ror32 ( *a, 22 ) );
+		maj = ( ( *a & *b ) ^ ( *a & *c ) ^ ( *b & *c ) );
+		t2 = ( s0 + maj );
+		s1 = ( ror32 ( *e, 6 ) ^ ror32 ( *e, 11 ) ^ ror32 ( *e, 25 ) );
+		ch = ( ( *e & *f ) ^ ( (~*e) & *g ) );
+		t1 = ( *h + s1 + ch + k[i] + w[i] );
+		*h = *g;
+		*g = *f;
+		*f = *e;
+		*e = ( *d + t1 );
+		*d = *c;
+		*c = *b;
+		*b = *a;
+		*a = ( t1 + t2 );
+		DBGC2 ( context, "%2d : %08x %08x %08x %08x %08x %08x %08x "
+			"%08x\n", i, *a, *b, *c, *d, *e, *f, *g, *h );
+	}
+
+	/* Add chunk to hash and convert back to big-endian */
+	for ( i = 0 ; i < 8 ; i++ ) {
+		context->ddd.dd.digest.h[i] =
+			cpu_to_be32 ( context->ddd.dd.digest.h[i] +
+				      u.ddd.dd.digest.h[i] );
+	}
+
+	DBGC ( context, "SHA256 digested:\n" );
+	DBGC_HDA ( context, 0, &context->ddd.dd.digest,
+		   sizeof ( context->ddd.dd.digest ) );
+}
+
+/**
+ * Accumulate data with SHA-256 algorithm
+ *
+ * @v ctx		SHA-256 context
+ * @v data		Data
+ * @v len		Length of data
+ */
+static void sha256_update ( void *ctx, const void *data, size_t len ) {
+	struct sha256_context *context = ctx;
+	const uint8_t *byte = data;
+	size_t offset;
+
+	/* Accumulate data a byte at a time, performing the digest
+	 * whenever we fill the data buffer
+	 */
+	while ( len-- ) {
+		offset = ( context->len % sizeof ( context->ddd.dd.data ) );
+		context->ddd.dd.data.byte[offset] = *(byte++);
+		context->len++;
+		if ( ( context->len % sizeof ( context->ddd.dd.data ) ) == 0 )
+			sha256_digest ( context );
+	}
+}
+
+/**
+ * Generate SHA-256 digest
+ *
+ * @v ctx		SHA-256 context
+ * @v out		Output buffer
+ */
+static void sha256_final ( void *ctx, void *out ) {
+	struct sha256_context *context = ctx;
+	uint64_t len_bits;
+	uint8_t pad;
+
+	/* Record length before pre-processing */
+	len_bits = cpu_to_be64 ( ( ( uint64_t ) context->len ) * 8 );
+
+	/* Pad with a single "1" bit followed by as many "0" bits as required */
+	pad = 0x80;
+	do {
+		sha256_update ( ctx, &pad, sizeof ( pad ) );
+		pad = 0x00;
+	} while ( ( context->len % sizeof ( context->ddd.dd.data ) ) !=
+		  offsetof ( typeof ( context->ddd.dd.data ), final.len ) );
+
+	/* Append length (in bits) */
+	sha256_update ( ctx, &len_bits, sizeof ( len_bits ) );
+	assert ( ( context->len % sizeof ( context->ddd.dd.data ) ) == 0 );
+
+	/* Copy out final digest */
+	memcpy ( out, &context->ddd.dd.digest,
+		 sizeof ( context->ddd.dd.digest ) );
+}
+
+/** SHA-256 algorithm */
+struct digest_algorithm sha256_algorithm = {
+	.name		= "sha256",
+	.ctxsize	= sizeof ( struct sha256_context ),
+	.blocksize	= sizeof ( union sha256_block ),
+	.digestsize	= sizeof ( struct sha256_digest ),
+	.init		= sha256_init,
+	.update		= sha256_update,
+	.final		= sha256_final,
+};
+
+/** "sha256" object identifier */
+static uint8_t oid_sha256[] = { ASN1_OID_SHA256 };
+
+/** "sha256" OID-identified algorithm */
+struct asn1_algorithm oid_sha256_algorithm __asn1_algorithm = {
+	.name = "sha256",
+	.digest = &sha256_algorithm,
+	.oid = ASN1_OID_CURSOR ( oid_sha256 ),
+};
diff --git a/roms/ipxe/src/crypto/x509.c b/roms/ipxe/src/crypto/x509.c
index 49bc2b8676dbd00c03ae9cc2ce57..df3c5c0de18023320a276d434eaf 100644
--- a/roms/ipxe/src/crypto/x509.c
+++ b/roms/ipxe/src/crypto/x509.c
@@ -13,7 +13,8 @@
  *
  * You should have received a copy of the GNU General Public License
  * along with this program; if not, write to the Free Software
- * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+ * 02110-1301, USA.
  */
 
 FILE_LICENCE ( GPL2_OR_LATER );
